
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ref cursor / iVAN</title>

    <meta name="description" content="ref cursor 利用REF CURSOR,可以在程序间传递结果集(一个程序里打开游标变量,在另外的程序里处理数据).也可以利用REF CURSOR实现BULK SQL,提高SQL性能. REF CURSOR分两种,Strong REF CURSOR 和 Weak REF CURSOR. Strong REF CURSOR:指定retrun type,CURSOR变量的类型必须和return type一致. DECLARE TYPE strongcurtyp IS REF CURSOR RETURN emp%RO">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ref cursor</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>利用REF CURSOR，可以在程序间传递结果集（一个程序里打开游标变量，在另外的程序里处理数据）。也可以利用REF CURSOR实现BULK SQL，提高SQL性能。</p>
<p>REF CURSOR分两种，Strong<br />
 REF CURSOR 和 Weak REF CURSOR。</p>
<p>Strong REF CURSOR:指定retrun type，CURSOR变量的类型必须和return type一致。<br />
DECLARE<br />
TYPE strongcurtyp IS REF CURSOR RETURN emp%ROWTYPE;<br />
emp_cv strongcurtyp;</p>
<p>Weak REF CURSOR:不指定return type，能和任何类型的CURSOR变量匹配。<br />
DECLARE<br />
TYPE weakcurtyp IS REF CURSOR;<br />
weak_cv weakcurtyp;<br />
any_cv SYS_REFCURSOR; --使用SYS_REFCURSOR可以使变量any_cv跟任何weak REF CURSOR类型匹配。</p>
<pre>问答：         CREATE OR REPLACE PACKAGE  '' AS
                       type cur is ref cursor</pre>
<p>        答案：</p>
<blockquote><blockquote>
<pre>整体的意思是“创建一个类型变量cur，它引用游标”，除了cur外，其余全是关键字。</pre>
</blockquote>
<blockquote><pre>TYPE cur：定义类型变量</pre>
</blockquote>
<blockquote><pre>is ref cursor：相当于数据类型，不过是引用游标的数据类型。</pre>
</blockquote>
<blockquote><pre>这种变量通常用于存储过程和函数返回结果集时使用，因为PL/SQL不允许存储过程或函数直接返回结果集，但可以返回类型变量，于是引用游标的类型变量作为输出参数或返回值就应运而生了。</pre>
</blockquote>
</blockquote>
<p> </p>
<h2>使用Strong REF CURSOR例子</h2>

<table>
<tbody>
<tr>
<td>
CREATE OR REPLACE PACKAGE emp_data AS<br />
TYPE empcurtyp IS REF CURSOR RETURN emp%rowtype; --定义TYPE as Strong REF CURSOR <br />
PROCEDURE open_emp_cv(emp_cv IN OUT empcurtyp, choice INT); --根据不同的choice选择不同的CURSOR<br />
PROCEDURE retrieve_data(choice INT); --通过调用procedure open_emp_cv，返回指定的结果集。<br />
END emp_data;</p>
<p>=============================================</p>
<p>CREATE OR REPLACE PACKAGE BODY emp_data AS</p>
<p>--procedure open_emp_cv-----------------------------</p>
<p>PROCEDURE open_emp_cv(emp_cv IN OUT empcurtyp, choice INT) IS --emp_cv作为传入/传出的CURSOR PARAMETER<br />
BEGIN<br />
IF choice = 1 THEN<br />
OPEN emp_cv FOR<br />
SELECT * FROM emp WHERE empno &lt; 7800;<br />
ELSIF choice = 2 THEN<br />
OPEN emp_cv FOR<br />
SELECT * FROM emp WHERE SAL &lt; 1000;<br />
ELSIF choice = 3 THEN<br />
OPEN emp_cv FOR<br />
SELECT * FROM emp WHERE ename like 'J%';<br />
END IF;<br />
END;</p>
<p>--procedure retrieve_data----------------------------------</p>
<p>PROCEDURE retrieve_data(choice INT) IS<br />
return_cv empcurtyp; --定义传入open_emp_cv的CURSOR变量<br />
return_row emp%ROWTYPE;<br />
invalid_choice EXCEPTION;<br />
BEGIN<br />
open_emp_cv(return_cv, choice); --调用 procedure OPEN_EMP_CV</p>
<p>IF choice = 1 THEN<br />
DBMS_OUTPUT.PUT_LINE('EMPLOYEES with empno less than 7800');<br />
ELSIF choice = 2 THEN<br />
DBMS_OUTPUT.PUT_LINE('EMPLOYEES with salary less than 1000');<br />
ELSIF choice = 3 THEN<br />
DBMS_OUTPUT.PUT_LINE('EMPLOYEES with name starts with ''J''');<br />
ELSE<br />
RAISE invalid_choice;<br />
END IF;</p>
<p>LOOP<br />
FETCH return_cv<br />
INTO return_row;<br />
EXIT WHEN return_cv%NOTFOUND;</p>
<p>DBMS_OUTPUT.PUT_LINE(return_row.empno || '--' || return_row.ename || '--' ||<br />
return_row.sal);<br />
END LOOP;</p>
<p>EXCEPTION<br />
WHEN invalid_choice THEN<br />
DBMS_OUTPUT.PUT_LINE('The CHOICE should be in one of (1,2,3)!');<br />
WHEN OTHERS THEN <br />
DBMS_OUTPUT.PUT_LINE('Errors in procedure RETRIEVE_DATA!');<br />
END;</p>
<p>END emp_data;</p>
<p>================================</p>
<p>执行：<br />
SQL&gt; EXEC emp_data.retrieve_data(1);<br />
EMPLOYEES with empno less than 7800<br />
7369--SMITH--800<br />
7499--ALLEN--1600<br />
7521--WARD--1250<br />
7566--JONES--2975<br />
7654--MARTIN--1250<br />
7698--BLAKE--2850<br />
7782--CLARK--2450<br />
7788--SCOTT--3000<br />
PL/SQL procedure successfully completed</p>
<p>SQL&gt; EXEC emp_data.retrieve_data(2);<br />
EMPLOYEES with salary less than 1000<br />
7369--SMITH--800<br />
7900--JAMES--950<br />
PL/SQL procedure successfully completed</p>
<p>SQL&gt; EXEC emp_data.retrieve_data(3);<br />
EMPLOYEES with name starts with 'J'<br />
7566--JONES--2975<br />
7900--JAMES--950<br />
PL/SQL procedure successfully completed</p>
<p>SQL&gt; EXEC emp_data.retrieve_data(34);<br />
The CHOICE should be in one of (1,2,3)!<br />
PL/SQL procedure successfully completed</p>
<h2>使用Weak REF CURSOR例子</h2>

<table>
<tbody>
<tr>
<td>
--procedure open_cv---------------------------------------</p>
<p>create or replace procedure open_cv(choice IN INT,<br />
return_cv OUT SYS_REFCURSOR) is<br />
--参数return_cv为weak REF CURSOR,利用SYS_CURSOR来定义<br />
begin<br />
if choice = 1 then<br />
open return_cv for 'select * from emp';<br />
elsif choice = 2 then<br />
open return_cv for 'select * from dept';<br />
end if;<br />
end open_cv;</p>
<p>--procedure retrieve_data------------------------------------</p>
<p>create or replace procedure retrieve_data(choice IN INT) is<br />
emp_rec emp%rowtype;<br />
dept_rec dept%rowtype;<br />
return_cv SYS_REFCURSOR;<br />
invalid_choice exception;<br />
begin<br />
if choice=1 then<br />
dbms_output.put_line('employee information');<br />
open_cv(1,return_cv); --调用procedure open_cv;<br />
loop<br />
fetch return_cv into emp_rec;<br />
exit when return_cv%notfound;<br />
dbms_output.put_line(emp_rec.empno||'-'||emp_rec.ename||'-'||emp_rec.sal);<br />
end loop;<br />
elsif choice=2 then<br />
dbms_output.put_line('department information');<br />
open_cv(2,return_cv);<br />
loop<br />
fetch return_cv into dept_rec;<br />
exit when return_cv%notfound;<br />
dbms_output.put_line(dept_rec.deptno||'-'||dept_rec.dname||'-'||dept_rec.loc);<br />
end loop;<br />
else<br />
raise invalid_choice;<br />
end if;</p>
<p>exception<br />
when invalid_choice then<br />
dbms_output.put_line('The CHOICE should be one of 1 and 2!');<br />
when others then<br />
dbms_output.put_line('Errors in procedure retrieve_data');<br />
end retrieve_data;</p>
<p>-----------------------------------------------------------------</p>
<p>执行：<br />
SQL&gt; exec retrieve_data(1);<br />
employee information<br />
7369-SMITH-800<br />
7499-ALLEN-1600<br />
7521-WARD-1250<br />
7566-JONES-2975<br />
7654-MARTIN-1250<br />
7698-BLAKE-2850<br />
......<br />
PL/SQL procedure successfully completed</p>
<p>SQL&gt; exec retrieve_data(2);<br />
department information<br />
10-ACCOUNTING-NEW YORK<br />
20-RESEARCH-DALLAS<br />
30-SALES-CHICAGO<br />
40-OPERATIONS-BOSTON<br />
PL/SQL procedure successfully completed</p>
<h2>用REF CURSOR实现BULK功能</h2>

<table>
<tbody>
<tr>
<td>
1. To speed up INSERT, UPDATE, and DELETE statements, enclose the SQL statement within a PL/SQL FORALL statement instead of a loop construct.<br />
2. To speed up SELECT statements, include the BULK COLLECT INTO clause in the SELECT statement instead of using INTO.</p>
<p>SQL&gt; create table tab2 as select empno ID, ename NAME, sal SALARY from emp where 1=2;<br />
Table created</p>
<p>-------------------------------------------------------</p>
<p>create or replace procedure REF_BULK is<br />
type empcurtyp is ref cursor;<br />
type idlist is table of emp.empno%type;<br />
type namelist is table of emp.ename%type;<br />
type sallist is table of emp.sal%type;</p>
<p>emp_cv empcurtyp;<br />
ids idlist;<br />
names namelist;<br />
sals sallist;</p>
<p>row_cnt number;<br />
begin<br />
open emp_cv for<br />
select empno, ename, sal from emp;<br />
fetch emp_cv BULK COLLECT<br />
INTO ids, names, sals; --BULK COLLECT INTO instead of INTO<br />
close emp_cv;</p>
<p>for i in ids.first .. ids.last loop<br />
dbms_output.put_line('id=' || ids(i) || ' name=' || names(i) ||<br />
' salary=' || sals(i));<br />
end loop;</p>
<p>forall i in ids.first .. ids.last --FORALL instead of FOR ...LOOP<br />
insert into tab2 values (ids(i), names(i), sals(i));<br />
commit;</p>
<p>select count(*) into row_cnt from tab2;<br />
dbms_output.put_line('-----------------------------------');<br />
dbms_output.put_line('The row number of tab2 is ' || row_cnt);<br />
end REF_BULK;</p>
<p>------------------------------------------------------------</p>
<p>执行：</p>
<p>SQL&gt; exec ref_bulk;</p>
<p>id=7369 name=SMITH salary=800<br />
id=7499 name=ALLEN salary=1600<br />
id=7521 name=WARD salary=1250<br />
id=7566 name=JONES salary=2975<br />
id=7654 name=MARTIN salary=1250<br />
id=7698 name=BLAKE salary=2850<br />
id=7782 name=CLARK salary=2450<br />
id=7788 name=SCOTT salary=3000<br />
id=7839 name=KING salary=5000<br />
id=7844 name=TURNER salary=1500<br />
id=7876 name=ADAMS salary=1100<br />
id=7900 name=JAMES salary=950<br />
id=7902 name=FORD salary=3000<br />
id=7934 name=MILLER salary=1300<br />
-----------------------------------<br />
The row number of tab2 is 14</p>
<p>PL/SQL procedure successfully completed</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 07:11:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%b1%bb%e5%9e%8b/" title="数据类型">数据类型</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ref cursor的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1REndp.html" rel="bookmark">如何使用REF CURSOR处理Oracle的结果集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle提供REF CURSOR,通过该功能可以实现在程序间传递结果集的功能,利用REF CURSOR也可以实现BULK SQL,从而提高SQL性能. 使用scott用户的emp表实现以下测试案例: SQL&gt; desc emp Name Null? Type ----------------------------------------- -------- ---------------------------- EMPNO NOT NULL NUMBER(4) ENAME VARCHAR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGj8Plp.html" rel="bookmark">Oracle 10g Release2新功能之Ref Cursor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Ref Cursor就是我们定义在服务器端的结果集的reference. 当我们打开一个Ref Cursor的时候,没有任何的数据返回到客户端,相反,数据在服务器上的地址将会被返回到客户端.这样用户就可以自己决定什么时间和以那种方式通过Ref Cursor去取数据. 在以前版本的ODP.NET中,我们可以通过Ref Cursor取数据,但是我们不能把Ref Cursor作为一个Input参数传递给PL/SQL的存储过程和存储函数.但是在Oracle Database 10g Release2,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0N9nmz.html" rel="bookmark">oracle中REF Cursor用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1,什么是 REF游标 ?  动态关联结果集的临时对象.即在运行的时候动态决定执行查询.   2,REF 游标 有什么作用?  实现在程序间传递结果集的功能,利用REF CURSOR也可以实现BULK SQL,从而提高SQL性能.   3,静态游标和REF 游标的区别是什么?  ①静态游标是静态定义,REF 游标是动态关联:  ②使用REF 游标需REF 游标变量.  ③REF 游标能做为参数进行传递,而静态游标是不可能的.   4,什么是REF 游标变量?  REF游标变量是一种 引用 REF			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmga6z.html" rel="bookmark">cursor-如何用OleDbCommand执行Oracle存储过程，返回REF CURSOR类型的结果集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何用OleDbCommand执行Oracle存储过程,返回REF CURSOR类型的结果集 如何用OleDb执行Oracle存储过程,返回REF CURSOR类型的结果集??? 如何设值OleDbCommand的Parameters啊? 要求用OleDb,而不是OracleClient! 该存储过程的参数如果只有一个CURSOR类型的结果集,或者一个CURSOR类型的结果集参数一个其他类型的参数,调用也没有问题, 一旦除了CURSOR类型的结果集参数外,还有两个或多个以上的参数时就不			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNj2BWM.html" rel="bookmark">高分急求oracleDataReader 读取 REF CURSOR问题！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我在.net访问oracle数据库的时候遇到一个问题调用oracle的分页的存储过程时.可以访问到返回的数据值,但是在读取数据集时,可以读到数据集的字段,但是读不到数据集的值.我在pl.sql中测试存储过程是没有问题的.代码如下:OracleCommandmyCommand=newOracleCommand(&quot;Pk_search.Pk_search_Page&quot;,myConnection);//MarktheCommandasaSPROCmyCommand.CommandTyp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqjQep.html" rel="bookmark">Sqlplus中调试带cursor的存储过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				存储过程 存储过程 create or replace package pkg_test as  type t_cursor is ref cursor;  procedure sp_get_catalogs(p_userid in number, cur_catalogs out t_cursor);end; create or replace package body pkg_test as  procedure sp_get_catalogs(p_userid in number, cur			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJk7Dqb.html" rel="bookmark">oracle中游标（Cursor）的详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 也许大家对数据库中游标都不陌生,但对于其概念可能有时又会有些模糊,游标到底是什么? 为了使大家对游标有个清晰的认识,本文将介绍Oracle中游标(curosr)相关的知识. 游标的概念 一般来讲,游标包含着两种不同的概念: 程序中的游标(Program Cursor)和Oracle中的游标(Oracle Curosr). 程序中的游标(Program Cursor): 在最终用户程序(Client Application)中,游标(curosr)通常指和SQL语句关联的一个数据结构,用于关			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVaeAmp.html" rel="bookmark">动态查询，动态生成cursor或者动态执行SQL的DML操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				定义PROCEDURE P1 ( P_Asset_Type IN varchar2,P_Asset_SubType IN varchar2,P_OrderIds IN varchar2). 需要根据传入参数动态查询,动态生成cursor或者动态执行SQL的DML操作. 1.简单的查询 SELECT   ABC from TableA where ORDER_ID IN ( P_OrderIds) : 2. 动态生成cursor 定义游标和变量: type   v_cursor   is   re			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qzDk1Op.html" rel="bookmark">oracle我是哪里的类型不匹配？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 oracle我是哪里的类型不匹配? 以下是代码!1 declare 2 type empcursor is ref cursor; 3 emp1 empcursor; 4 avgSal number; 5 deptno number; 6 empid number; 7 empSalary number; 8 begin 9 deptno:=&amp;deptno;10 if deptno=2 then11 select avg(salary) into avgSal from emp whe			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz72Erp.html" rel="bookmark" class="title">实现自己的Lock对象</a>
					<div>
						一直想好好学习concurrent包中的各个类的实现,然而经常看了一点就因为其他事情干扰而放下了.发现这样太不利于自己的成长了,因而最近打算潜心一件一件的完成自己想学习的东西. 对concurrent ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrWD4p.html" rel="bookmark" class="title">Struts2配置web&period;xml</a>
					<div>
						  任何MVC框架都需要与Web应用整合,这就不得不借助于web.xml文件,只有配置在web.xml文件中Servlet才会被应用加载. 所有的MVC框架都需要Web应用加载一个核心控制器,对于St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5rLRz.html" rel="bookmark" class="title">生命的印记-做草根的经历</a>
					<div>
						 在刚刚踏进这个行业之初,觉得自己什么也不知道,一个简单的FTP软件的正常应用我就在网吧研究了一天(那个时候自己还没有计算机),结果把程序传上去了,但目录还是没有搞清楚,网站还是无法访问.这也就是在2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBqANz.html" rel="bookmark" class="title">王通：百度的屁股能不能摸？</a>
					<div>
						前一段,我写了一篇&lt;赶驴网事件的SEO启发&gt;,通过赶驴网事件分析了google和百度两家搜索引擎的不同,特别强调了google算法靠机器,百度算法人工干涉比较多. 在我写那篇文章之后几个小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpk67rM.html" rel="bookmark" class="title">只有形成品牌才能超脱搜索引擎的依赖</a>
					<div>
						百度现在又火了,百度之前不是要和360干起来,结果没有干起来.不过却是和站长干起来了,确切的说是站长和百度干起来了. 众所周知的6.22和6.28已成为站长的蛋疼之日,不知道明年的那天会不会有人去祭奠 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPlw0M.html" rel="bookmark" class="title">用Python编写网络爬虫（七）：Python中的正则表达式教程</a>
					<div>
						接下来准备用糗百做一个爬虫的小例子. 但是在这之前,先详细的整理一下Python中的正则表达式的相关内容. 正则表达式在Python爬虫中的作用就像是老师点名时用的花名册一样,是必不可少的神兵利器.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPKvoz.html" rel="bookmark" class="title">SQL Server数据导入导出技术概述与比较</a>
					<div>
						当我们建立一个数据库时,并且想将分散在各处的不同类型的数据库分类汇总在这个新建的数据库中时,尤其是在进行数据检验.净化和转换时,将会面临很大的挑战.幸好SQL Server为我们提供了强大.丰富的数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjKGlp.html" rel="bookmark" class="title">Linux系统中使用iostat分析IO性能</a>
					<div>
						对于I/O-bond类型的进程,我们经常用iostat工具查看进程IO请求下发的数量.系统处理IO请求的耗时,进而分析进程与操作系统的交互过程中IO方面是否存在瓶颈. 下面通过iostat命令使用实例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7nYjb.html" rel="bookmark" class="title">Oracle中dba&comma;sysdba&comma;sysoper和normal等各种用户的区别</a>
					<div>
						1.sys和system用户的区别 system用户只能用normal身份登陆em. sys用户具有&quot;SYSDBA&quot;或者&quot;SYSOPER&quot;权限,登陆em也只能用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7xJVb.html" rel="bookmark" class="title">Photoshop给河边女孩添加夕阳美景效果</a>
					<div>
						  Photoshop给河边女孩添加夕阳美景效果            最终效果 原图 1.打开原图素材大图,创建可选颜色调整图层,对黄色,绿色进行调整,参数及效果如下图.这一步给图片增加橙黄色. 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oB5qb.html" rel="bookmark" class="title">spring MVC 使用注解返回json</a>
					<div>
						使用spring MVC框架时,如何使用注解返回json呢? Java代码   @ResponseBody       @RequestMapping(value = &quot;/login&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOavr8M.html" rel="bookmark" class="title">Linux下的七个类Dropbox同步工具推荐</a>
					<div>
						[51CTO精选译文]不少51CTO读者朋友们都询问过Linux平台下的Dropbox替代软件的问题,而目前国内的几家,金山快盘. Dbank.Everbox.酷盘.微盘这几个产品,目前对Linux的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGaOwb.html" rel="bookmark" class="title">盛大游戏与中青宝宣布，将在上海自贸区合资成立网游公司</a>
					<div>
						摘要: 查看最新行情 昨天, 盛大游戏 与中青宝宣布,将在上海自贸区合资成立网游公司,并推首款游戏&lt;战争世界&gt;.盛大游戏CEO张向东说,尽管自贸区暂未开放网络游戏运营,但中国网游 查看最新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWn2Lp.html" rel="bookmark" class="title">【转载】NIO-SelectableChannel</a>
					<div>
						本文转载自http://shift-alt-ctrl.iteye.com/blog/1841324   SelectableChannel(&quot;可被选择&quot;通道):抽象类,此类实现了I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrW5GM.html" rel="bookmark" class="title">盘点2012年15大图片视频及拍照应用</a>
					<div>
						在2012这一年,IT行业可谓是势头凶猛,据美国科技博客The Next Web周一评选中,评出了2012年15项最佳图片.视频及拍照应用,其中 Instagram.YouTube和QuickShot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNj2lPM.html" rel="bookmark" class="title">聊天室-请问这个滚动条应该怎么设置</a>
					<div>
						问题描述 请问这个滚动条应该怎么设置 各位前辈们大家好,请问这个滚动条应该怎么设置,当我接受到消息的时候,滚动条不向下走,一直向上跑,这个是怎么回事呢? 解决方案 没听懂你的意思啊.说具体点阿					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRnO3b.html" rel="bookmark" class="title">WebBrowser编程简述</a>
					<div>
						原文:WebBrowser编程简述1.初始化和终止化(Initialization &amp; Finalization) 大家在执行TWebBrowser的某个方法以进行期望的操作,如ExecWB等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBqerM.html" rel="bookmark" class="title">企业库Caching与Interception有冲突吗</a>
					<div>
						问题描述 在工程里使用企业库的Caching缓存,只要一引用企业库的Microsoft.Practices.Unity.Interception.dll就报错,不引用Caching就能正常使用,这是为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBJVZM.html" rel="bookmark" class="title">董海平推出安全软件365门神与360卫士相似引猜疑</a>
					<div>
						消息人士透露,在2006年因讨伐流氓软件声名鹊起的董海平已经将注意力转向了安全软件领域.据悉,董海平已经于近期推出一款针对网上病毒.木马和非法网络广告的安全工具软件365门神. 名字与360卫士相似, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZPQyM.html" rel="bookmark" class="title">争议P2P聚焦七个核心问题：鞋带绑好了再跑</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 P2P:鞋带绑好了再跑 聂伟柱 李静瑕 就在商业银行挣扎于利率市场化.金融脱媒的当下,以人人贷.第三方支付.阿里金融等为代表的互联网金融迅速崛起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY2POp.html" rel="bookmark" class="title">骗子网&OpenCurlyDoubleQuote;傍&rdquo;名嘴　提防爱心被忽悠</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 央视&lt;经济半小时&gt;日前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBmKjz.html" rel="bookmark" class="title">【winform】怎么在form2里的textbox里对form1的treeview节点之进行修改？</a>
					<div>
						问题描述 [winform]怎么在form2里的textbox里对form1的treeview节点之进行修改? form1里有个treeview,现在选中其节点弹出form2的textbox 现在希望 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeodrjM.html" rel="bookmark" class="title">框架-nuxeo gadgets怎么删除</a>
					<div>
						问题描述 nuxeo gadgets怎么删除 在nuxeo框架中删除gadgets中的部分小插件怎么删除?求大神					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyqoNz.html" rel="bookmark" class="title">菜鸟站长：每只菜鸟都有鹰的梦想</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 2009年,我即将毕业.二月的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jNWRp.html" rel="bookmark" class="title">Shell脚本实现删除邮件队列&lowbar;linux shell</a>
					<div>
						最近遇到了一个麻烦事:机器上邮件队列里老是被塞满,但是又不知道是什么地方发邮件写入的,十分蛋疼,没办法,只有临时处理一下了,写了个删除邮件的脚本rm_mqueue.sh. 复制代码 代码如下: #/b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1W0Wb.html" rel="bookmark" class="title">基于BootStrap Metronic开发框架经验小结【二】列表分页处理和插件JSTree的使用&lowbar;javascript技巧</a>
					<div>
						在上篇基于BootStrap Metronic开发框架经验小结[一]框架总览及菜单模块的处理,介绍了Bootstrap开发框架的一些基础性概括,包括总体界面效果,以及布局.菜单等内容,本篇继续这一主题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8OEOb.html" rel="bookmark" class="title">用脚本调用样式的几种方法&lowbar;javascript技巧</a>
					<div>
						之前经常遇见classname.csstext之类的词,却不知道如何用.最近着手网站实际建设,收获颇多,给还不懂的人分享一下. 通常在网页中样式表的调用方法有四种.第一是外链,即&lt;link re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWrm3z.html" rel="bookmark" class="title">Android布局案例之人人android九宫格&lowbar;Android</a>
					<div>
						人人android是人人网推出的一款优秀的手机应用软件,我们在使用的时候发现他的首页布局是九宫格模式的,让人觉得很别致,因为现在很多的 android软件很少使用这种布局模式,人人android使用的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z7VAz.html" rel="bookmark" class="title">SQL 查询和删除重复字段数据的方法&lowbar;MsSql</a>
					<div>
						例如: id           name         value 1               a                 pp 2               a           ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2Z9mM.html" rel="bookmark" class="title">安装MYECLIPSE不给力啊</a>
					<div>
						问题描述 我用的WIN7安装到最后一点的时候不动了.这种情况以前遇到过,但是我强行推出后还是可以正常使用的,但是今天重新装系统后就装不上了,我从搜狗上下的资源MyEclipse_6.0.1GA_E3. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
